       #include <p12f675.inc>
             LIST        p=12F675    ;   .
            __CONFIG    01F94H 


Sec         equ         20h
Sec0        equ         21h
shet        equ         22h
w_temp      equ         23h
status_temp equ         24h
timer       equ         25h
skv         equ         26h
skvperem    equ         27h
skvpost     equ         28h
kolsec      equ         2Ah

skvpuls     equ         2Bh
flag        equ         2Ch
logvar      equ         2Eh
varL        equ         2Fh
ost         equ         30h


#define    knreg         GPIO,3
#define    knbol         GPIO,1
#define    knmen         GPIO,2
#define    svet          GPIO,0




            org         0           ;      0 PC.
            goto        Start       ;    Start.

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  ,   3-   (8   )
;   330
              
            org         4           
           
inter       movwf       w_temp
            swapf       STATUS,W
            movwf       status_temp

            movf        skvperem,W
            movwf       skv
            comf        skv,F
            incfsz      timer,F
            goto        a1
            bcf         svet           
a1          movf        timer,W
            subwf       skv,W
            btfss       STATUS,C ;12                             
            bsf         svet                        
            
            bcf         INTCON,T0IF 
            movlw       .235
            movwf       TMR0  
            swapf       status_temp,W
            movwf       STATUS
            swapf       w_temp,F
            swapf       w_temp,W
            retfie                     ;30 


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

Start       movlw       b'00000111'
            movwf       CMCON
            movlw       b'00000000'
            movwf       GPIO
            
            bsf         STATUS,RP0
            movlw       .0
            movwf       ANSEL
            movlw       b'11111110'
            movwf       TRISIO
            
            bcf         STATUS,RP0
           
            
            bcf         svet
            movlw       .0
            movwf       timer
            movlw       .255
            movwf       skvpost
            movlw       .7
            movwf       kolsec
            
           

            
            bcf         INTCON,T0IF        ;   TMR0
            clrf        TMR0               ;  TMR0
            bsf         INTCON,T0IE        ;  TMR0
            bsf         STATUS,RP0 
            bcf         OPTION_REG,T0CS    ;   TMR0
            bcf         STATUS,RP0

            bsf         INTCON,GIE


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

            goto       puls
poston      movf       skvpost,W
            
            movwf      skvperem
c2          btfsc      knbol
            goto       c1           
            movlw      .25
            movwf      shet
ca1         call       pausknp
            btfsc      knbol
            goto       ca3
            decfsz     shet,F
            goto       ca1
ca2         call       bolsvt
            call       pause
            btfsc      knbol
            goto       c1
            goto       ca2

ca3         call       bolsvt


c1          btfsc      knmen
            goto       c3
            movlw      .25
            movwf      shet
cb1         call       pausknp
            btfsc      knmen
            goto       cb3
            decfsz     shet,F
            goto       cb1
cb2         call       mensvt
            call       pause
            btfsc      knmen
            goto       c3
            goto       cb2
           
cb3         call       mensvt


c3          btfss      knreg
            goto       ce1
            bsf        flag,0
            goto       c2
ce1         btfss      flag,0
            goto       c2
            bcf        flag,0
            goto       puls



bolsvt      movlw      .255
            subwf      skvpost,W
            btfsc      STATUS,Z
            return
            incf       skvpost,F
            movf       skvpost,W
           
            movwf      skvperem
            return


mensvt      movlw      .0
            subwf      skvpost,W
            btfsc      STATUS,Z
            return
            decf       skvpost,F
            movf       skvpost,W
          
            movwf      skvperem
            return



puls        clrf       skvperem
b4          movf       kolsec,W
            call       pauspuls
               
            movlw      .255
            subwf      skvperem,W
            btfsc      STATUS,Z
            goto       umen
            incf       skvperem,F
            
            call       opros
            btfss      knreg
            goto       cd1
            bsf        flag,0
            goto       b4
cd1         btfss      flag,0
            goto       b4
            bcf        flag,0
            goto       poston

umen        movf       kolsec,W
            call       pauspuls
            
          
            movlw      .0
            subwf      skvperem,W
            btfsc      STATUS,Z
            goto       b4
            decf       skvperem,F
            
            call       opros
            btfss      knreg
            goto       cd2
            bsf        flag,0
            goto       umen
cd2         btfss      flag,0
            goto       umen
            bcf        flag,0
            goto       poston



       
            
opros       btfss      knbol
            goto       bb1
            bsf        flag,1
            goto       mendl
bb1         btfss      flag,1
            goto       mendl
            bcf        flag,1
            movlw      .26
            subwf      kolsec,W
            btfsc      STATUS,Z
            return
            incf       kolsec,F
            return

mendl       btfss      knmen
            goto       bb2
            bsf        flag,2
            return
bb2         btfss      flag,2
            return
            bcf        flag,2
            movlw      .3
            subwf      kolsec,W
            btfsc      STATUS,Z
            return
            decf       kolsec,F
            return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  

pause        movlw       .9
             movwf       Sec
p2           movlw       .255
             movwf       Sec0
p1           decfsz      Sec0,F
             goto        p1
             decfsz      Sec,F
             goto        p2
             return

pausknp      movlw       .12
             movwf       Sec
p4           movlw       .255
             movwf       Sec0
p3           decfsz      Sec0,F
             goto        p3
             decfsz      Sec,F
             goto        p4
             return       


pauspuls     movwf       Sec
p6           movlw       .255
             movwf       Sec0
p5           decfsz      Sec0,F
             goto        p5
             decfsz      Sec,F
             goto        p6
             return       
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;




             END    




